Bug 443968 - [enh] ifcfg-rh: handle device aliases
[enh] ifcfg-rh: handle device aliases
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: NetworkManager (Show other bugs)
14
All Linux
low Severity high
: ---
: ---
Assigned To: Dan Williams
Fedora Extras Quality Assurance
: Reopened, Triaged
: 474901 490274 509641 561589 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-24 09:06 EDT by Davide Moretti
Modified: 2012-08-16 17:51 EDT (History)
19 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-16 17:50:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
[PATCH] support ifcfg aliases (9.64 KB, patch)
2010-11-09 09:56 EST, Jirka Klimes
no flags Details | Diff

  None (edit)
Description Davide Moretti 2008-04-24 09:06:44 EDT
Description of problem:
NetworkManager doesn't enable device aliases to let network devices have
multiple IPs

Version-Release number of selected component (if applicable):
NetworkManager-0.7.0-0.9.2.svn3566.fc9.i386

How reproducible:
Always

Steps to Reproduce:
1. create a /etc/sysconfig/network-scripts/ifcfg-eth0:1 file (using
system-config-network cgecjubg "Activate device when parent device starts" or by
hand, enabling ONPARENT=yes) with a second static IP config for the device eth0

2. Restart NetworkManager
  
Actual results:
eth0 will respond only to primary IP and eth0:1 is inactive

Expected results:
eth0 should respond to both IP addresses and show eth0:1 in ifconfig

Additional info:
When clicking on the nm-applet desktop icon, it shows both System eth0
interfaces but you still can enable only one at a time.

The lack of multiple IP assignment to a network interface precludes the
systemwide NetworkManager replacement of the standard network script in some
scenarios (like web servers)
Comment 1 Bug Zapper 2008-05-14 06:04:18 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bill C. Riemers 2008-06-05 05:18:06 EDT
I am seeing a similar type problem.  After installing Fedora 9 my network failed
to start automatically.   NetworkManager showed the two Wired connections, both
marked as "never", and not started.

Manually running:

service network restart

starts the network normally.

After investigating, I found that neither of my wired network connections were
marked as controlled by NetworkManager.  I marked both connections as managed by
network manager, and manually entered the Mac address into NetworkManager.

After that, NetworkManager was able to start connection 1, but not connection 2.
 Since I am not using wireless, I finally decided just to use the good old
"network" init.d script, and to disable NetworkManager.

So the two features I could not get to work with NetworkManager:
  1. For NetworkManager to work automatically post install.
  2. Multicasting with DHCP and a static address.
  3. Both IPV6 and IPV4 enabled.
 
Here is my networking-script configurations that work with "network" but I can't
get to work with NetworkManager:

[root@localhost network-scripts]# grep -v DNS1 ifcfg-eth0 | grep -v SEARCH
# Broadcom Corporation NetXtreme BCM5752 Gigabit Ethernet PCI Express
DEVICE=eth0
BOOTPROTO=dhcp
HWADDR=00:19:b9:11:5e:e2
IPV6INIT=yes
IPV6_AUTOCONF=yes
ONBOOT=yes
NM_CONTROLLED=no
TYPE=Ethernet
USERCTL=yes
PEERDNS=yes

[root@localhost network-scripts]# grep -v DNS1 ifcfg-eth0:1 |grep -v SEARCH
# Please read /usr/share/doc/initscripts-*/sysconfig.txt
# for the documentation of these parameters.
TYPE=Ethernet
DEVICE=eth0:1
BOOTPROTO=none
NETMASK=255.255.255.0
IPADDR=192.168.2.201
USERCTL=yes
PEERDNS=yes
IPV6INIT=no
ONPARENT=yes
NM_CONTROLLED=no

Comment 3 Bill C. Riemers 2008-06-05 05:19:13 EDT
See related bug #439103
Comment 4 Dan Williams 2009-02-13 07:32:43 EST
*** Bug 474901 has been marked as a duplicate of this bug. ***
Comment 5 Jessica Sterling 2009-03-05 10:33:01 EST
This bug has been triaged

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 6 Dan Williams 2009-03-16 13:18:08 EDT
*** Bug 490274 has been marked as a duplicate of this bug. ***
Comment 7 Bug Zapper 2009-06-09 20:24:23 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Davide Moretti 2009-06-10 04:33:13 EDT
Bumped to F10 for now.... I have to check in F11...
Comment 9 Davide Moretti 2009-06-10 08:39:33 EDT
NetworkManager on F11 allows to assign multiple IP to an interface so this issue is resolved in F11.
Comment 10 Dan Williams 2009-10-16 17:51:23 EDT
(it did that in F10 too)

but we still need to at least interpret the ifcfg-eth0:1 style files in /etc/sysconfig/network-scripts in the ifcfg-rh system settings backend plugin.
Comment 11 Dan Williams 2009-11-11 20:34:58 EST
*** Bug 509641 has been marked as a duplicate of this bug. ***
Comment 12 Bug Zapper 2009-11-16 03:05:08 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Dan Williams 2010-02-08 20:42:44 EST
*** Bug 561589 has been marked as a duplicate of this bug. ***
Comment 14 Pete Gale 2010-04-19 17:30:35 EDT
It still exists in the release version of Fedora 12.

Additionally, if you work around this bug by defining the loopback (eth0:1) in rc.local, it will get disabled later on. /var/log/messages says that ntpd is disabling it, but that could be due to this issue.
Comment 15 Steve Bonneville 2010-10-29 17:41:01 EDT
This is especially fun in conjunction with RHEL 6 bug 633984 where initscripts can't understand how NetworkManager sets multiple IP addresses the modern way on a single interface, either.  So there's no consistent way to set multiple IPs per interface in the configuration files that both initscripts and NetworkManager understand.  (Mind you, I'd be happy if initscripts understood IPADDR2/PREFIX2, but it'd be best if everything worked either way.)
Comment 16 Bug Zapper 2010-11-04 07:56:24 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 17 Jirka Klimes 2010-11-09 09:56:07 EST
Created attachment 459129 [details]
[PATCH] support ifcfg aliases

The patch implements basic alias support in 'ifcfg-rh' plugin.
It recognizes alias files and puts the addresses to base connection instead of creating another connection.

However, the implementation has several limitations and differences against initscripts. As a legacy thing, I think, it's not worth to completely simulate initscripts behaviour, as it would require big effort and some workarounds in NM.    

Differences, not implemented stuff:
- ifcfg-$DEV-range* files with IP ranges are not implemented
- no virtual interfaces are created (all addresses are configured on main interface)
- updating a connection merges all IPs into main ifcfg file and alias files are removed
- base file has to have manual IP configuration (when it's DHCP, IP aliases won't be added)

Review, comments, suggestions, improvements are welcomed.
Comment 18 Bug Zapper 2010-12-05 02:11:23 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 19 Jirka Klimes 2010-12-06 05:09:25 EST
Dan, would you find a while to review the patch?
Comment 20 Lancelot Mak 2012-02-10 18:49:20 EST
F16
NetworkManager is not capable of making alias, at least not GUI configurable way.
Comment 21 Dan Williams 2012-02-11 00:25:16 EST
(In reply to comment #20)
> F16
> NetworkManager is not capable of making alias, at least not GUI configurable
> way.

It's not capable of making aliases, but you certainly can configure multiple IP addresses on the same interface, which was the whole point of the hack that is interface aliases in the first place.
Comment 22 Dan Williams 2012-02-11 00:27:06 EST
(In reply to comment #17)
> Created attachment 459129 [details]
> [PATCH] support ifcfg aliases
> 
> The patch implements basic alias support in 'ifcfg-rh' plugin.
> It recognizes alias files and puts the addresses to base connection instead of
> creating another connection.
> 
> However, the implementation has several limitations and differences against
> initscripts. As a legacy thing, I think, it's not worth to completely simulate
> initscripts behaviour, as it would require big effort and some workarounds in
> NM.    
> 
> Differences, not implemented stuff:
> - ifcfg-$DEV-range* files with IP ranges are not implemented
> - no virtual interfaces are created (all addresses are configured on main
> interface)
> - updating a connection merges all IPs into main ifcfg file and alias files are
> removed
> - base file has to have manual IP configuration (when it's DHCP, IP aliases
> won't be added)
> 
> Review, comments, suggestions, improvements are welcomed.

Patch looks good from a quick review, though we should definitely get some testcases for this functionality too.
Comment 23 Fedora End Of Life 2012-08-16 17:51:04 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.